// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from state_estimation_msgs:msg/EstimatorInnovation.idl
// generated code does not contain a copyright notice

#ifndef STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_INNOVATION__STRUCT_HPP_
#define STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_INNOVATION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__state_estimation_msgs__msg__EstimatorInnovation __attribute__((deprecated))
#else
# define DEPRECATED__state_estimation_msgs__msg__EstimatorInnovation __declspec(deprecated)
#endif

namespace state_estimation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EstimatorInnovation_
{
  using Type = EstimatorInnovation_<ContainerAllocator>;

  explicit EstimatorInnovation_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_sample_us = 0ull;
      std::fill<typename std::array<double, 3>::iterator, double>(this->vision_position.begin(), this->vision_position.end(), 0.0);
      this->baro_vertical_position = 0.0;
      this->heading = 0.0;
    }
  }

  explicit EstimatorInnovation_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    vision_position(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_sample_us = 0ull;
      std::fill<typename std::array<double, 3>::iterator, double>(this->vision_position.begin(), this->vision_position.end(), 0.0);
      this->baro_vertical_position = 0.0;
      this->heading = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _time_sample_us_type =
    uint64_t;
  _time_sample_us_type time_sample_us;
  using _vision_position_type =
    std::array<double, 3>;
  _vision_position_type vision_position;
  using _baro_vertical_position_type =
    double;
  _baro_vertical_position_type baro_vertical_position;
  using _heading_type =
    double;
  _heading_type heading;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__time_sample_us(
    const uint64_t & _arg)
  {
    this->time_sample_us = _arg;
    return *this;
  }
  Type & set__vision_position(
    const std::array<double, 3> & _arg)
  {
    this->vision_position = _arg;
    return *this;
  }
  Type & set__baro_vertical_position(
    const double & _arg)
  {
    this->baro_vertical_position = _arg;
    return *this;
  }
  Type & set__heading(
    const double & _arg)
  {
    this->heading = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator> *;
  using ConstRawPtr =
    const state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__state_estimation_msgs__msg__EstimatorInnovation
    std::shared_ptr<state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__state_estimation_msgs__msg__EstimatorInnovation
    std::shared_ptr<state_estimation_msgs::msg::EstimatorInnovation_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EstimatorInnovation_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->time_sample_us != other.time_sample_us) {
      return false;
    }
    if (this->vision_position != other.vision_position) {
      return false;
    }
    if (this->baro_vertical_position != other.baro_vertical_position) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    return true;
  }
  bool operator!=(const EstimatorInnovation_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EstimatorInnovation_

// alias to use template instance with default allocator
using EstimatorInnovation =
  state_estimation_msgs::msg::EstimatorInnovation_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace state_estimation_msgs

#endif  // STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_INNOVATION__STRUCT_HPP_
