// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from state_estimation_msgs:msg/EstimatorInnovation.idl
// generated code does not contain a copyright notice

#ifndef STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_INNOVATION__TRAITS_HPP_
#define STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_INNOVATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "state_estimation_msgs/msg/detail/estimator_innovation__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace state_estimation_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EstimatorInnovation & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: time_sample_us
  {
    out << "time_sample_us: ";
    rosidl_generator_traits::value_to_yaml(msg.time_sample_us, out);
    out << ", ";
  }

  // member: vision_position
  {
    if (msg.vision_position.size() == 0) {
      out << "vision_position: []";
    } else {
      out << "vision_position: [";
      size_t pending_items = msg.vision_position.size();
      for (auto item : msg.vision_position) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: baro_vertical_position
  {
    out << "baro_vertical_position: ";
    rosidl_generator_traits::value_to_yaml(msg.baro_vertical_position, out);
    out << ", ";
  }

  // member: heading
  {
    out << "heading: ";
    rosidl_generator_traits::value_to_yaml(msg.heading, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EstimatorInnovation & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: time_sample_us
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_sample_us: ";
    rosidl_generator_traits::value_to_yaml(msg.time_sample_us, out);
    out << "\n";
  }

  // member: vision_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.vision_position.size() == 0) {
      out << "vision_position: []\n";
    } else {
      out << "vision_position:\n";
      for (auto item : msg.vision_position) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: baro_vertical_position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "baro_vertical_position: ";
    rosidl_generator_traits::value_to_yaml(msg.baro_vertical_position, out);
    out << "\n";
  }

  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading: ";
    rosidl_generator_traits::value_to_yaml(msg.heading, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EstimatorInnovation & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace state_estimation_msgs

namespace rosidl_generator_traits
{

[[deprecated("use state_estimation_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const state_estimation_msgs::msg::EstimatorInnovation & msg,
  std::ostream & out, size_t indentation = 0)
{
  state_estimation_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use state_estimation_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const state_estimation_msgs::msg::EstimatorInnovation & msg)
{
  return state_estimation_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<state_estimation_msgs::msg::EstimatorInnovation>()
{
  return "state_estimation_msgs::msg::EstimatorInnovation";
}

template<>
inline const char * name<state_estimation_msgs::msg::EstimatorInnovation>()
{
  return "state_estimation_msgs/msg/EstimatorInnovation";
}

template<>
struct has_fixed_size<state_estimation_msgs::msg::EstimatorInnovation>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<state_estimation_msgs::msg::EstimatorInnovation>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<state_estimation_msgs::msg::EstimatorInnovation>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_INNOVATION__TRAITS_HPP_
