// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from state_estimation_msgs:msg/EstimatorSensorBias.idl
// generated code does not contain a copyright notice
#include "state_estimation_msgs/msg/detail/estimator_sensor_bias__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
state_estimation_msgs__msg__EstimatorSensorBias__init(state_estimation_msgs__msg__EstimatorSensorBias * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    state_estimation_msgs__msg__EstimatorSensorBias__fini(msg);
    return false;
  }
  // time_sample_us
  // gyro_bias
  // gyro_bias_variance
  // acceleration_bias
  // acceleration_bias_variance
  // gyro_bias_valid
  // gyro_bias_stable
  // acceleration_bias_valid
  // acceleration_bias_stable
  return true;
}

void
state_estimation_msgs__msg__EstimatorSensorBias__fini(state_estimation_msgs__msg__EstimatorSensorBias * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // time_sample_us
  // gyro_bias
  // gyro_bias_variance
  // acceleration_bias
  // acceleration_bias_variance
  // gyro_bias_valid
  // gyro_bias_stable
  // acceleration_bias_valid
  // acceleration_bias_stable
}

bool
state_estimation_msgs__msg__EstimatorSensorBias__are_equal(const state_estimation_msgs__msg__EstimatorSensorBias * lhs, const state_estimation_msgs__msg__EstimatorSensorBias * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // time_sample_us
  if (lhs->time_sample_us != rhs->time_sample_us) {
    return false;
  }
  // gyro_bias
  for (size_t i = 0; i < 3; ++i) {
    if (lhs->gyro_bias[i] != rhs->gyro_bias[i]) {
      return false;
    }
  }
  // gyro_bias_variance
  for (size_t i = 0; i < 3; ++i) {
    if (lhs->gyro_bias_variance[i] != rhs->gyro_bias_variance[i]) {
      return false;
    }
  }
  // acceleration_bias
  for (size_t i = 0; i < 3; ++i) {
    if (lhs->acceleration_bias[i] != rhs->acceleration_bias[i]) {
      return false;
    }
  }
  // acceleration_bias_variance
  for (size_t i = 0; i < 3; ++i) {
    if (lhs->acceleration_bias_variance[i] != rhs->acceleration_bias_variance[i]) {
      return false;
    }
  }
  // gyro_bias_valid
  if (lhs->gyro_bias_valid != rhs->gyro_bias_valid) {
    return false;
  }
  // gyro_bias_stable
  if (lhs->gyro_bias_stable != rhs->gyro_bias_stable) {
    return false;
  }
  // acceleration_bias_valid
  if (lhs->acceleration_bias_valid != rhs->acceleration_bias_valid) {
    return false;
  }
  // acceleration_bias_stable
  if (lhs->acceleration_bias_stable != rhs->acceleration_bias_stable) {
    return false;
  }
  return true;
}

bool
state_estimation_msgs__msg__EstimatorSensorBias__copy(
  const state_estimation_msgs__msg__EstimatorSensorBias * input,
  state_estimation_msgs__msg__EstimatorSensorBias * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // time_sample_us
  output->time_sample_us = input->time_sample_us;
  // gyro_bias
  for (size_t i = 0; i < 3; ++i) {
    output->gyro_bias[i] = input->gyro_bias[i];
  }
  // gyro_bias_variance
  for (size_t i = 0; i < 3; ++i) {
    output->gyro_bias_variance[i] = input->gyro_bias_variance[i];
  }
  // acceleration_bias
  for (size_t i = 0; i < 3; ++i) {
    output->acceleration_bias[i] = input->acceleration_bias[i];
  }
  // acceleration_bias_variance
  for (size_t i = 0; i < 3; ++i) {
    output->acceleration_bias_variance[i] = input->acceleration_bias_variance[i];
  }
  // gyro_bias_valid
  output->gyro_bias_valid = input->gyro_bias_valid;
  // gyro_bias_stable
  output->gyro_bias_stable = input->gyro_bias_stable;
  // acceleration_bias_valid
  output->acceleration_bias_valid = input->acceleration_bias_valid;
  // acceleration_bias_stable
  output->acceleration_bias_stable = input->acceleration_bias_stable;
  return true;
}

state_estimation_msgs__msg__EstimatorSensorBias *
state_estimation_msgs__msg__EstimatorSensorBias__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  state_estimation_msgs__msg__EstimatorSensorBias * msg = (state_estimation_msgs__msg__EstimatorSensorBias *)allocator.allocate(sizeof(state_estimation_msgs__msg__EstimatorSensorBias), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(state_estimation_msgs__msg__EstimatorSensorBias));
  bool success = state_estimation_msgs__msg__EstimatorSensorBias__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
state_estimation_msgs__msg__EstimatorSensorBias__destroy(state_estimation_msgs__msg__EstimatorSensorBias * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    state_estimation_msgs__msg__EstimatorSensorBias__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
state_estimation_msgs__msg__EstimatorSensorBias__Sequence__init(state_estimation_msgs__msg__EstimatorSensorBias__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  state_estimation_msgs__msg__EstimatorSensorBias * data = NULL;

  if (size) {
    data = (state_estimation_msgs__msg__EstimatorSensorBias *)allocator.zero_allocate(size, sizeof(state_estimation_msgs__msg__EstimatorSensorBias), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = state_estimation_msgs__msg__EstimatorSensorBias__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        state_estimation_msgs__msg__EstimatorSensorBias__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
state_estimation_msgs__msg__EstimatorSensorBias__Sequence__fini(state_estimation_msgs__msg__EstimatorSensorBias__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      state_estimation_msgs__msg__EstimatorSensorBias__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

state_estimation_msgs__msg__EstimatorSensorBias__Sequence *
state_estimation_msgs__msg__EstimatorSensorBias__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  state_estimation_msgs__msg__EstimatorSensorBias__Sequence * array = (state_estimation_msgs__msg__EstimatorSensorBias__Sequence *)allocator.allocate(sizeof(state_estimation_msgs__msg__EstimatorSensorBias__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = state_estimation_msgs__msg__EstimatorSensorBias__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
state_estimation_msgs__msg__EstimatorSensorBias__Sequence__destroy(state_estimation_msgs__msg__EstimatorSensorBias__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    state_estimation_msgs__msg__EstimatorSensorBias__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
state_estimation_msgs__msg__EstimatorSensorBias__Sequence__are_equal(const state_estimation_msgs__msg__EstimatorSensorBias__Sequence * lhs, const state_estimation_msgs__msg__EstimatorSensorBias__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!state_estimation_msgs__msg__EstimatorSensorBias__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
state_estimation_msgs__msg__EstimatorSensorBias__Sequence__copy(
  const state_estimation_msgs__msg__EstimatorSensorBias__Sequence * input,
  state_estimation_msgs__msg__EstimatorSensorBias__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(state_estimation_msgs__msg__EstimatorSensorBias);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    state_estimation_msgs__msg__EstimatorSensorBias * data =
      (state_estimation_msgs__msg__EstimatorSensorBias *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!state_estimation_msgs__msg__EstimatorSensorBias__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          state_estimation_msgs__msg__EstimatorSensorBias__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!state_estimation_msgs__msg__EstimatorSensorBias__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
