// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from state_estimation_msgs:msg/EstimatorSensorBias.idl
// generated code does not contain a copyright notice

#ifndef STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_SENSOR_BIAS__STRUCT_HPP_
#define STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_SENSOR_BIAS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__state_estimation_msgs__msg__EstimatorSensorBias __attribute__((deprecated))
#else
# define DEPRECATED__state_estimation_msgs__msg__EstimatorSensorBias __declspec(deprecated)
#endif

namespace state_estimation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EstimatorSensorBias_
{
  using Type = EstimatorSensorBias_<ContainerAllocator>;

  explicit EstimatorSensorBias_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_sample_us = 0ull;
      std::fill<typename std::array<double, 3>::iterator, double>(this->gyro_bias.begin(), this->gyro_bias.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->gyro_bias_variance.begin(), this->gyro_bias_variance.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->acceleration_bias.begin(), this->acceleration_bias.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->acceleration_bias_variance.begin(), this->acceleration_bias_variance.end(), 0.0);
      this->gyro_bias_valid = false;
      this->gyro_bias_stable = false;
      this->acceleration_bias_valid = false;
      this->acceleration_bias_stable = false;
    }
  }

  explicit EstimatorSensorBias_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    gyro_bias(_alloc),
    gyro_bias_variance(_alloc),
    acceleration_bias(_alloc),
    acceleration_bias_variance(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->time_sample_us = 0ull;
      std::fill<typename std::array<double, 3>::iterator, double>(this->gyro_bias.begin(), this->gyro_bias.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->gyro_bias_variance.begin(), this->gyro_bias_variance.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->acceleration_bias.begin(), this->acceleration_bias.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->acceleration_bias_variance.begin(), this->acceleration_bias_variance.end(), 0.0);
      this->gyro_bias_valid = false;
      this->gyro_bias_stable = false;
      this->acceleration_bias_valid = false;
      this->acceleration_bias_stable = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _time_sample_us_type =
    uint64_t;
  _time_sample_us_type time_sample_us;
  using _gyro_bias_type =
    std::array<double, 3>;
  _gyro_bias_type gyro_bias;
  using _gyro_bias_variance_type =
    std::array<double, 3>;
  _gyro_bias_variance_type gyro_bias_variance;
  using _acceleration_bias_type =
    std::array<double, 3>;
  _acceleration_bias_type acceleration_bias;
  using _acceleration_bias_variance_type =
    std::array<double, 3>;
  _acceleration_bias_variance_type acceleration_bias_variance;
  using _gyro_bias_valid_type =
    bool;
  _gyro_bias_valid_type gyro_bias_valid;
  using _gyro_bias_stable_type =
    bool;
  _gyro_bias_stable_type gyro_bias_stable;
  using _acceleration_bias_valid_type =
    bool;
  _acceleration_bias_valid_type acceleration_bias_valid;
  using _acceleration_bias_stable_type =
    bool;
  _acceleration_bias_stable_type acceleration_bias_stable;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__time_sample_us(
    const uint64_t & _arg)
  {
    this->time_sample_us = _arg;
    return *this;
  }
  Type & set__gyro_bias(
    const std::array<double, 3> & _arg)
  {
    this->gyro_bias = _arg;
    return *this;
  }
  Type & set__gyro_bias_variance(
    const std::array<double, 3> & _arg)
  {
    this->gyro_bias_variance = _arg;
    return *this;
  }
  Type & set__acceleration_bias(
    const std::array<double, 3> & _arg)
  {
    this->acceleration_bias = _arg;
    return *this;
  }
  Type & set__acceleration_bias_variance(
    const std::array<double, 3> & _arg)
  {
    this->acceleration_bias_variance = _arg;
    return *this;
  }
  Type & set__gyro_bias_valid(
    const bool & _arg)
  {
    this->gyro_bias_valid = _arg;
    return *this;
  }
  Type & set__gyro_bias_stable(
    const bool & _arg)
  {
    this->gyro_bias_stable = _arg;
    return *this;
  }
  Type & set__acceleration_bias_valid(
    const bool & _arg)
  {
    this->acceleration_bias_valid = _arg;
    return *this;
  }
  Type & set__acceleration_bias_stable(
    const bool & _arg)
  {
    this->acceleration_bias_stable = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator> *;
  using ConstRawPtr =
    const state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__state_estimation_msgs__msg__EstimatorSensorBias
    std::shared_ptr<state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__state_estimation_msgs__msg__EstimatorSensorBias
    std::shared_ptr<state_estimation_msgs::msg::EstimatorSensorBias_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EstimatorSensorBias_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->time_sample_us != other.time_sample_us) {
      return false;
    }
    if (this->gyro_bias != other.gyro_bias) {
      return false;
    }
    if (this->gyro_bias_variance != other.gyro_bias_variance) {
      return false;
    }
    if (this->acceleration_bias != other.acceleration_bias) {
      return false;
    }
    if (this->acceleration_bias_variance != other.acceleration_bias_variance) {
      return false;
    }
    if (this->gyro_bias_valid != other.gyro_bias_valid) {
      return false;
    }
    if (this->gyro_bias_stable != other.gyro_bias_stable) {
      return false;
    }
    if (this->acceleration_bias_valid != other.acceleration_bias_valid) {
      return false;
    }
    if (this->acceleration_bias_stable != other.acceleration_bias_stable) {
      return false;
    }
    return true;
  }
  bool operator!=(const EstimatorSensorBias_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EstimatorSensorBias_

// alias to use template instance with default allocator
using EstimatorSensorBias =
  state_estimation_msgs::msg::EstimatorSensorBias_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace state_estimation_msgs

#endif  // STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_SENSOR_BIAS__STRUCT_HPP_
