// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from state_estimation_msgs:msg/EstimatorSensorBias.idl
// generated code does not contain a copyright notice

#ifndef STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_SENSOR_BIAS__TRAITS_HPP_
#define STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_SENSOR_BIAS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "state_estimation_msgs/msg/detail/estimator_sensor_bias__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace state_estimation_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EstimatorSensorBias & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: time_sample_us
  {
    out << "time_sample_us: ";
    rosidl_generator_traits::value_to_yaml(msg.time_sample_us, out);
    out << ", ";
  }

  // member: gyro_bias
  {
    if (msg.gyro_bias.size() == 0) {
      out << "gyro_bias: []";
    } else {
      out << "gyro_bias: [";
      size_t pending_items = msg.gyro_bias.size();
      for (auto item : msg.gyro_bias) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: gyro_bias_variance
  {
    if (msg.gyro_bias_variance.size() == 0) {
      out << "gyro_bias_variance: []";
    } else {
      out << "gyro_bias_variance: [";
      size_t pending_items = msg.gyro_bias_variance.size();
      for (auto item : msg.gyro_bias_variance) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: acceleration_bias
  {
    if (msg.acceleration_bias.size() == 0) {
      out << "acceleration_bias: []";
    } else {
      out << "acceleration_bias: [";
      size_t pending_items = msg.acceleration_bias.size();
      for (auto item : msg.acceleration_bias) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: acceleration_bias_variance
  {
    if (msg.acceleration_bias_variance.size() == 0) {
      out << "acceleration_bias_variance: []";
    } else {
      out << "acceleration_bias_variance: [";
      size_t pending_items = msg.acceleration_bias_variance.size();
      for (auto item : msg.acceleration_bias_variance) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: gyro_bias_valid
  {
    out << "gyro_bias_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.gyro_bias_valid, out);
    out << ", ";
  }

  // member: gyro_bias_stable
  {
    out << "gyro_bias_stable: ";
    rosidl_generator_traits::value_to_yaml(msg.gyro_bias_stable, out);
    out << ", ";
  }

  // member: acceleration_bias_valid
  {
    out << "acceleration_bias_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_bias_valid, out);
    out << ", ";
  }

  // member: acceleration_bias_stable
  {
    out << "acceleration_bias_stable: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_bias_stable, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EstimatorSensorBias & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: time_sample_us
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "time_sample_us: ";
    rosidl_generator_traits::value_to_yaml(msg.time_sample_us, out);
    out << "\n";
  }

  // member: gyro_bias
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.gyro_bias.size() == 0) {
      out << "gyro_bias: []\n";
    } else {
      out << "gyro_bias:\n";
      for (auto item : msg.gyro_bias) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: gyro_bias_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.gyro_bias_variance.size() == 0) {
      out << "gyro_bias_variance: []\n";
    } else {
      out << "gyro_bias_variance:\n";
      for (auto item : msg.gyro_bias_variance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: acceleration_bias
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.acceleration_bias.size() == 0) {
      out << "acceleration_bias: []\n";
    } else {
      out << "acceleration_bias:\n";
      for (auto item : msg.acceleration_bias) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: acceleration_bias_variance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.acceleration_bias_variance.size() == 0) {
      out << "acceleration_bias_variance: []\n";
    } else {
      out << "acceleration_bias_variance:\n";
      for (auto item : msg.acceleration_bias_variance) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: gyro_bias_valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gyro_bias_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.gyro_bias_valid, out);
    out << "\n";
  }

  // member: gyro_bias_stable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gyro_bias_stable: ";
    rosidl_generator_traits::value_to_yaml(msg.gyro_bias_stable, out);
    out << "\n";
  }

  // member: acceleration_bias_valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_bias_valid: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_bias_valid, out);
    out << "\n";
  }

  // member: acceleration_bias_stable
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "acceleration_bias_stable: ";
    rosidl_generator_traits::value_to_yaml(msg.acceleration_bias_stable, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EstimatorSensorBias & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace state_estimation_msgs

namespace rosidl_generator_traits
{

[[deprecated("use state_estimation_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const state_estimation_msgs::msg::EstimatorSensorBias & msg,
  std::ostream & out, size_t indentation = 0)
{
  state_estimation_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use state_estimation_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const state_estimation_msgs::msg::EstimatorSensorBias & msg)
{
  return state_estimation_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<state_estimation_msgs::msg::EstimatorSensorBias>()
{
  return "state_estimation_msgs::msg::EstimatorSensorBias";
}

template<>
inline const char * name<state_estimation_msgs::msg::EstimatorSensorBias>()
{
  return "state_estimation_msgs/msg/EstimatorSensorBias";
}

template<>
struct has_fixed_size<state_estimation_msgs::msg::EstimatorSensorBias>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<state_estimation_msgs::msg::EstimatorSensorBias>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<state_estimation_msgs::msg::EstimatorSensorBias>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_SENSOR_BIAS__TRAITS_HPP_
