// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from state_estimation_msgs:msg/EstimatorState.idl
// generated code does not contain a copyright notice

#ifndef STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_STATE__STRUCT_HPP_
#define STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'orientation'
#include "geometry_msgs/msg/detail/quaternion__struct.hpp"
// Member 'velocity'
// Member 'delta_angle_bias'
// Member 'delta_velocity_bias'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__state_estimation_msgs__msg__EstimatorState __attribute__((deprecated))
#else
# define DEPRECATED__state_estimation_msgs__msg__EstimatorState __declspec(deprecated)
#endif

namespace state_estimation_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EstimatorState_
{
  using Type = EstimatorState_<ContainerAllocator>;

  explicit EstimatorState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    orientation(_init),
    velocity(_init),
    position(_init),
    delta_angle_bias(_init),
    delta_velocity_bias(_init)
  {
    (void)_init;
  }

  explicit EstimatorState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    orientation(_alloc, _init),
    velocity(_alloc, _init),
    position(_alloc, _init),
    delta_angle_bias(_alloc, _init),
    delta_velocity_bias(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _orientation_type =
    geometry_msgs::msg::Quaternion_<ContainerAllocator>;
  _orientation_type orientation;
  using _velocity_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _velocity_type velocity;
  using _position_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _position_type position;
  using _delta_angle_bias_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _delta_angle_bias_type delta_angle_bias;
  using _delta_velocity_bias_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _delta_velocity_bias_type delta_velocity_bias;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__orientation(
    const geometry_msgs::msg::Quaternion_<ContainerAllocator> & _arg)
  {
    this->orientation = _arg;
    return *this;
  }
  Type & set__velocity(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->velocity = _arg;
    return *this;
  }
  Type & set__position(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position = _arg;
    return *this;
  }
  Type & set__delta_angle_bias(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->delta_angle_bias = _arg;
    return *this;
  }
  Type & set__delta_velocity_bias(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->delta_velocity_bias = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    state_estimation_msgs::msg::EstimatorState_<ContainerAllocator> *;
  using ConstRawPtr =
    const state_estimation_msgs::msg::EstimatorState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<state_estimation_msgs::msg::EstimatorState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<state_estimation_msgs::msg::EstimatorState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      state_estimation_msgs::msg::EstimatorState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<state_estimation_msgs::msg::EstimatorState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      state_estimation_msgs::msg::EstimatorState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<state_estimation_msgs::msg::EstimatorState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<state_estimation_msgs::msg::EstimatorState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<state_estimation_msgs::msg::EstimatorState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__state_estimation_msgs__msg__EstimatorState
    std::shared_ptr<state_estimation_msgs::msg::EstimatorState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__state_estimation_msgs__msg__EstimatorState
    std::shared_ptr<state_estimation_msgs::msg::EstimatorState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EstimatorState_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->orientation != other.orientation) {
      return false;
    }
    if (this->velocity != other.velocity) {
      return false;
    }
    if (this->position != other.position) {
      return false;
    }
    if (this->delta_angle_bias != other.delta_angle_bias) {
      return false;
    }
    if (this->delta_velocity_bias != other.delta_velocity_bias) {
      return false;
    }
    return true;
  }
  bool operator!=(const EstimatorState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EstimatorState_

// alias to use template instance with default allocator
using EstimatorState =
  state_estimation_msgs::msg::EstimatorState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace state_estimation_msgs

#endif  // STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_STATE__STRUCT_HPP_
