// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from state_estimation_msgs:msg/EstimatorState.idl
// generated code does not contain a copyright notice

#ifndef STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_STATE__TRAITS_HPP_
#define STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "state_estimation_msgs/msg/detail/estimator_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'orientation'
#include "geometry_msgs/msg/detail/quaternion__traits.hpp"
// Member 'velocity'
// Member 'delta_angle_bias'
// Member 'delta_velocity_bias'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"
// Member 'position'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace state_estimation_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EstimatorState & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: orientation
  {
    out << "orientation: ";
    to_flow_style_yaml(msg.orientation, out);
    out << ", ";
  }

  // member: velocity
  {
    out << "velocity: ";
    to_flow_style_yaml(msg.velocity, out);
    out << ", ";
  }

  // member: position
  {
    out << "position: ";
    to_flow_style_yaml(msg.position, out);
    out << ", ";
  }

  // member: delta_angle_bias
  {
    out << "delta_angle_bias: ";
    to_flow_style_yaml(msg.delta_angle_bias, out);
    out << ", ";
  }

  // member: delta_velocity_bias
  {
    out << "delta_velocity_bias: ";
    to_flow_style_yaml(msg.delta_velocity_bias, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EstimatorState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: orientation
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation:\n";
    to_block_style_yaml(msg.orientation, out, indentation + 2);
  }

  // member: velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "velocity:\n";
    to_block_style_yaml(msg.velocity, out, indentation + 2);
  }

  // member: position
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position:\n";
    to_block_style_yaml(msg.position, out, indentation + 2);
  }

  // member: delta_angle_bias
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "delta_angle_bias:\n";
    to_block_style_yaml(msg.delta_angle_bias, out, indentation + 2);
  }

  // member: delta_velocity_bias
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "delta_velocity_bias:\n";
    to_block_style_yaml(msg.delta_velocity_bias, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EstimatorState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace state_estimation_msgs

namespace rosidl_generator_traits
{

[[deprecated("use state_estimation_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const state_estimation_msgs::msg::EstimatorState & msg,
  std::ostream & out, size_t indentation = 0)
{
  state_estimation_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use state_estimation_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const state_estimation_msgs::msg::EstimatorState & msg)
{
  return state_estimation_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<state_estimation_msgs::msg::EstimatorState>()
{
  return "state_estimation_msgs::msg::EstimatorState";
}

template<>
inline const char * name<state_estimation_msgs::msg::EstimatorState>()
{
  return "state_estimation_msgs/msg/EstimatorState";
}

template<>
struct has_fixed_size<state_estimation_msgs::msg::EstimatorState>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Point>::value && has_fixed_size<geometry_msgs::msg::Quaternion>::value && has_fixed_size<geometry_msgs::msg::Vector3>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<state_estimation_msgs::msg::EstimatorState>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Point>::value && has_bounded_size<geometry_msgs::msg::Quaternion>::value && has_bounded_size<geometry_msgs::msg::Vector3>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<state_estimation_msgs::msg::EstimatorState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // STATE_ESTIMATION_MSGS__MSG__DETAIL__ESTIMATOR_STATE__TRAITS_HPP_
