// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from state_estimation_msgs:msg/EstimatorState.idl
// generated code does not contain a copyright notice
#include "state_estimation_msgs/msg/detail/estimator_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `orientation`
#include "geometry_msgs/msg/detail/quaternion__functions.h"
// Member `velocity`
// Member `delta_angle_bias`
// Member `delta_velocity_bias`
#include "geometry_msgs/msg/detail/vector3__functions.h"
// Member `position`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
state_estimation_msgs__msg__EstimatorState__init(state_estimation_msgs__msg__EstimatorState * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    state_estimation_msgs__msg__EstimatorState__fini(msg);
    return false;
  }
  // orientation
  if (!geometry_msgs__msg__Quaternion__init(&msg->orientation)) {
    state_estimation_msgs__msg__EstimatorState__fini(msg);
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__Vector3__init(&msg->velocity)) {
    state_estimation_msgs__msg__EstimatorState__fini(msg);
    return false;
  }
  // position
  if (!geometry_msgs__msg__Point__init(&msg->position)) {
    state_estimation_msgs__msg__EstimatorState__fini(msg);
    return false;
  }
  // delta_angle_bias
  if (!geometry_msgs__msg__Vector3__init(&msg->delta_angle_bias)) {
    state_estimation_msgs__msg__EstimatorState__fini(msg);
    return false;
  }
  // delta_velocity_bias
  if (!geometry_msgs__msg__Vector3__init(&msg->delta_velocity_bias)) {
    state_estimation_msgs__msg__EstimatorState__fini(msg);
    return false;
  }
  return true;
}

void
state_estimation_msgs__msg__EstimatorState__fini(state_estimation_msgs__msg__EstimatorState * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // orientation
  geometry_msgs__msg__Quaternion__fini(&msg->orientation);
  // velocity
  geometry_msgs__msg__Vector3__fini(&msg->velocity);
  // position
  geometry_msgs__msg__Point__fini(&msg->position);
  // delta_angle_bias
  geometry_msgs__msg__Vector3__fini(&msg->delta_angle_bias);
  // delta_velocity_bias
  geometry_msgs__msg__Vector3__fini(&msg->delta_velocity_bias);
}

bool
state_estimation_msgs__msg__EstimatorState__are_equal(const state_estimation_msgs__msg__EstimatorState * lhs, const state_estimation_msgs__msg__EstimatorState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // orientation
  if (!geometry_msgs__msg__Quaternion__are_equal(
      &(lhs->orientation), &(rhs->orientation)))
  {
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->velocity), &(rhs->velocity)))
  {
    return false;
  }
  // position
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->position), &(rhs->position)))
  {
    return false;
  }
  // delta_angle_bias
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->delta_angle_bias), &(rhs->delta_angle_bias)))
  {
    return false;
  }
  // delta_velocity_bias
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->delta_velocity_bias), &(rhs->delta_velocity_bias)))
  {
    return false;
  }
  return true;
}

bool
state_estimation_msgs__msg__EstimatorState__copy(
  const state_estimation_msgs__msg__EstimatorState * input,
  state_estimation_msgs__msg__EstimatorState * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // orientation
  if (!geometry_msgs__msg__Quaternion__copy(
      &(input->orientation), &(output->orientation)))
  {
    return false;
  }
  // velocity
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->velocity), &(output->velocity)))
  {
    return false;
  }
  // position
  if (!geometry_msgs__msg__Point__copy(
      &(input->position), &(output->position)))
  {
    return false;
  }
  // delta_angle_bias
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->delta_angle_bias), &(output->delta_angle_bias)))
  {
    return false;
  }
  // delta_velocity_bias
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->delta_velocity_bias), &(output->delta_velocity_bias)))
  {
    return false;
  }
  return true;
}

state_estimation_msgs__msg__EstimatorState *
state_estimation_msgs__msg__EstimatorState__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  state_estimation_msgs__msg__EstimatorState * msg = (state_estimation_msgs__msg__EstimatorState *)allocator.allocate(sizeof(state_estimation_msgs__msg__EstimatorState), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(state_estimation_msgs__msg__EstimatorState));
  bool success = state_estimation_msgs__msg__EstimatorState__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
state_estimation_msgs__msg__EstimatorState__destroy(state_estimation_msgs__msg__EstimatorState * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    state_estimation_msgs__msg__EstimatorState__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
state_estimation_msgs__msg__EstimatorState__Sequence__init(state_estimation_msgs__msg__EstimatorState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  state_estimation_msgs__msg__EstimatorState * data = NULL;

  if (size) {
    data = (state_estimation_msgs__msg__EstimatorState *)allocator.zero_allocate(size, sizeof(state_estimation_msgs__msg__EstimatorState), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = state_estimation_msgs__msg__EstimatorState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        state_estimation_msgs__msg__EstimatorState__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
state_estimation_msgs__msg__EstimatorState__Sequence__fini(state_estimation_msgs__msg__EstimatorState__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      state_estimation_msgs__msg__EstimatorState__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

state_estimation_msgs__msg__EstimatorState__Sequence *
state_estimation_msgs__msg__EstimatorState__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  state_estimation_msgs__msg__EstimatorState__Sequence * array = (state_estimation_msgs__msg__EstimatorState__Sequence *)allocator.allocate(sizeof(state_estimation_msgs__msg__EstimatorState__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = state_estimation_msgs__msg__EstimatorState__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
state_estimation_msgs__msg__EstimatorState__Sequence__destroy(state_estimation_msgs__msg__EstimatorState__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    state_estimation_msgs__msg__EstimatorState__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
state_estimation_msgs__msg__EstimatorState__Sequence__are_equal(const state_estimation_msgs__msg__EstimatorState__Sequence * lhs, const state_estimation_msgs__msg__EstimatorState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!state_estimation_msgs__msg__EstimatorState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
state_estimation_msgs__msg__EstimatorState__Sequence__copy(
  const state_estimation_msgs__msg__EstimatorState__Sequence * input,
  state_estimation_msgs__msg__EstimatorState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(state_estimation_msgs__msg__EstimatorState);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    state_estimation_msgs__msg__EstimatorState * data =
      (state_estimation_msgs__msg__EstimatorState *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!state_estimation_msgs__msg__EstimatorState__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          state_estimation_msgs__msg__EstimatorState__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!state_estimation_msgs__msg__EstimatorState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
